# python imports
import socket, types, string
# our imports

__version__ = "$Revision: 1.5 $"

class icfpIO:
  """base class for ICFP IO"""
  def __init__(self, descriptor):
    self._sock_buff = ''
    if (types.TupleType == type(descriptor)):
      self._sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
      self._sock.connect(descriptor)
    else:
      self._sock = descriptor

    return

  def readline(self):
    """return one line from the socket"""
    i = string.find(self._sock_buff, "\n")
    if (i != -1):
      retval = self._sock_buff[:i]
      self._sock_buff = self._sock_buff[i+1:]
      return retval
    else:
      new_stuff = self._sock.recv(1024)
      if (len(new_stuff) == 0):
        return None # likely a closed connection
      self._sock_buff += new_stuff
      return self.readline()

    print "Unreachable"
    return None # unreachable

  def write(self, string):
    """write a string to the socket"""
    #    print "-->'%s'" % (string)
    return self._sock.send(string)

  def close(self):
    """Close the guy"""

    self._sock.close()
    return

      
