# python imports
import os, string
# our imports

"""This module provides a simple interface to read our
   /proc process entry and figure out how many jiffies
   (1/100 of a second) we are using

   NOTE: This actually uses a float representing the
   time, this was much faster than the proc interface
   I just haven't renamed stuff yet
"""

__version__ = "$Revision: 1.1 $"

class Jiffies:
  """Keep track of our jiffies"""
  def __init__(self):
    self._turns = 1
    self._pid = os.getpid()
    self.procfile = '/proc/%d/stat' % (self._pid)
    self._jiffies = self.get_jiffies()
    self._start = self._jiffies
    return

  def get_jiffies(self):
    """Get our current jiffie count"""
    parts = os.times()[0:4]
    return parts[0] + parts[1] + parts[2] + parts[3]
  
  def get_jiffies_slow(self):
    """Get our current jiffie count"""
    
    fob = file(self.procfile, 'r')
    line = fob.read()
    fob.close()
    parts = string.split(line)
    # pid (bin) state ppid pgrp session tty tpgid flags min_flt cmin_flt maj_flt cmaj_flt utime stime cutime cstime counter ...
    #  0    1     2    3    4      5     6    7     8     9       10        11      12      13   14    15     16      17    ...

    (j_user, j_sys, jc_user, jc_sys) = parts[13:17] # us plus all our kids (if any)
    return int(j_user) + int(j_sys) + int(jc_user) + int(jc_sys)

  def avg_jiffies(self):
    return (self._jiffies / self._turns)

  def bump_turn(self):
    self._turns += 1
    self._jiffies = self.get_jiffies()

  def test(self):
    print self.get_jiffies()
